diff --git a/src/Lunr/Vortex/FCM/FCMDispatcher.php b/src/Lunr/Vortex/FCM/FCMDispatcher.php
index afabc935168e037a489549d29633c01bf9fbc98e..c91393a1b7420ca1ee94c954023166b9a5d7f406 100644
--- a/src/Lunr/Vortex/FCM/FCMDispatcher.php
+++ b/src/Lunr/Vortex/FCM/FCMDispatcher.php
@@ -12,6 +12,8 @@
 namespace Lunr\Vortex\FCM;
 
 use Lunr\Vortex\PushNotificationMultiDispatcherInterface;
+use Lunr\Vortex\PushNotificationResponseInterface;
+use Psr\Log\LoggerInterface;
 use Requests_Exception;
 use Requests_Response;
 
@@ -25,37 +27,37 @@ class FCMDispatcher implements PushNotificationMultiDispatcherInterface
      * Maximum number of endpoints allowed in one push.
      * @var integer
      */
-    const BATCH_SIZE = 1000;
+    private const BATCH_SIZE = 1000;
 
     /**
      * Push Notification authentication token.
      * @var string
      */
-    protected $auth_token;
+    protected string $auth_token;
 
     /**
      * Shared instance of the Requests_Session class.
      * @var \Requests_Session
      */
-    protected $http;
+    protected \Requests_Session $http;
 
     /**
      * Shared instance of a Logger class.
      * @var \Psr\Log\LoggerInterface
      */
-    protected $logger;
+    protected LoggerInterface $logger;
 
     /**
      * Url to send the FCM push notification to.
      * @var string
      */
-    const GOOGLE_SEND_URL = 'https://fcm.googleapis.com/fcm/send';
+    private const GOOGLE_SEND_URL = 'https://fcm.googleapis.com/fcm/send';
 
     /**
      * Service name.
      * @var string
      */
-    const SERVICE_NAME = 'FCM';
+    private const SERVICE_NAME = 'FCM';
 
     /**
      * Constructor.
@@ -63,7 +65,7 @@ class FCMDispatcher implements PushNotificationMultiDispatcherInterface
      * @param \Requests_Session        $http   Shared instance of the Requests_Session class.
      * @param \Psr\Log\LoggerInterface $logger Shared instance of a Logger.
      */
-    public function __construct($http, $logger)
+    public function __construct(\Requests_Session $http, LoggerInterface $logger)
     {
         $this->http       = $http;
         $this->logger     = $logger;
@@ -85,7 +87,7 @@ class FCMDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return FCMResponse
      */
-    public function get_response()
+    public function get_response(): FCMResponse
     {
         return new FCMResponse();
     }
@@ -100,7 +102,7 @@ class FCMDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return FCMBatchResponse
      */
-    public function get_batch_response($http_response, $logger, $endpoints, $payload)
+    public function get_batch_response(\Requests_Response $http_response, LoggerInterface $logger, array $endpoints, string $payload): FCMBatchResponse
     {
         return new FCMBatchResponse($http_response, $logger, $endpoints, $payload);
     }
@@ -111,9 +113,9 @@ class FCMDispatcher implements PushNotificationMultiDispatcherInterface
      * @param FCMPayload $payload   Payload object
      * @param array      $endpoints Endpoints to send to in this batch
      *
-     * @return FCMResponse Response object
+     * @return PushNotificationResponseInterface&FCMResponse Response object
      */
-    public function push($payload, &$endpoints)
+    public function push(object $payload, array &$endpoints): PushNotificationResponseInterface
     {
         $gcm_response = $this->get_response();
 
@@ -139,7 +141,7 @@ class FCMDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return FCMBatchResponse Response object
      */
-    protected function push_batch($payload, &$endpoints)
+    protected function push_batch(FCMPayload $payload, array &$endpoints)
     {
         $headers = [
             'Content-Type'  => 'application/json',
@@ -180,9 +182,7 @@ class FCMDispatcher implements PushNotificationMultiDispatcherInterface
             }
         }
 
-        $gcm_batch_response = $this->get_batch_response($http_response, $this->logger, $endpoints, json_encode($tmp_payload));
-
-        return $gcm_batch_response;
+        return $this->get_batch_response($http_response, $this->logger, $endpoints, json_encode($tmp_payload));
     }
 
     /**
@@ -192,7 +192,7 @@ class FCMDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return FCMDispatcher Self reference
      */
-    public function set_auth_token($auth_token)
+    public function set_auth_token(string $auth_token): self
     {
         $this->auth_token = $auth_token;
 
@@ -204,7 +204,7 @@ class FCMDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return \Requests_Response New instance of a Requests_Response object.
      */
-    protected function get_new_response_object_for_failed_request()
+    protected function get_new_response_object_for_failed_request(): \Requests_Response
     {
         $http_response = new Requests_Response();
 
diff --git a/src/Lunr/Vortex/FCM/FCMPayload.php b/src/Lunr/Vortex/FCM/FCMPayload.php
index 140d9f191133dd3e99c9fdac72e019129fe57124..f615730ac0864777fdb654fe70809bd6cf8bf2dc 100644
--- a/src/Lunr/Vortex/FCM/FCMPayload.php
+++ b/src/Lunr/Vortex/FCM/FCMPayload.php
@@ -23,7 +23,7 @@ class FCMPayload
      * Array of Push Notification elements.
      * @var array
      */
-    protected $elements;
+    protected array $elements;
 
     /**
      * Constructor.
@@ -48,7 +48,7 @@ class FCMPayload
      *
      * @return string FCMPayload
      */
-    public function get_payload()
+    public function get_payload(): string
     {
         return json_encode($this->elements);
     }
@@ -63,7 +63,7 @@ class FCMPayload
      *
      * @return FCMPayload Self Reference
      */
-    public function set_collapse_key($key)
+    public function set_collapse_key(string $key): self
     {
         $this->elements['collapse_key'] = $key;
 
@@ -79,7 +79,7 @@ class FCMPayload
      *
      * @return FCMPayload Self Reference
      */
-    public function set_data($data)
+    public function set_data(array $data): self
     {
         $this->elements['data'] = $data;
 
@@ -96,7 +96,7 @@ class FCMPayload
      *
      * @return FCMPayload Self Reference
      */
-    public function set_time_to_live($ttl)
+    public function set_time_to_live(int $ttl): self
     {
         $this->elements['time_to_live'] = $ttl;
 
@@ -108,7 +108,7 @@ class FCMPayload
      *
      * @return boolean TRUE if condition is present.
      */
-    public function has_condition()
+    public function has_condition(): bool
     {
         return isset($this->elements['condition']);
     }
@@ -118,7 +118,7 @@ class FCMPayload
      *
      * @return boolean TRUE if condition is present.
      */
-    public function has_topic()
+    public function has_topic(): bool
     {
         return isset($this->elements['topic']);
     }
@@ -132,7 +132,7 @@ class FCMPayload
      *
      * @return FCMPayload Self Reference
      */
-    public function set_notification($notification)
+    public function set_notification(array $notification): self
     {
         $this->elements['notification'] = $notification;
 
@@ -146,7 +146,7 @@ class FCMPayload
      *
      * @return FCMPayload Self Reference
      */
-    public function set_content_available($val)
+    public function set_content_available(bool $val): self
     {
         $this->elements['content_available'] = $val;
 
@@ -160,7 +160,7 @@ class FCMPayload
      *
      * @return FCMPayload Self Reference
      */
-    public function set_topic($topic)
+    public function set_topic(string $topic): self
     {
         $this->elements['topic'] = $topic;
 
@@ -178,7 +178,7 @@ class FCMPayload
      *
      * @return FCMPayload Self Reference
      */
-    public function set_condition($condition)
+    public function set_condition(string $condition): self
     {
         $this->elements['condition'] = $condition;
 
@@ -192,7 +192,7 @@ class FCMPayload
      *
      * @return FCMPayload Self Reference
      */
-    public function set_mutable_content($mutable)
+    public function set_mutable_content(bool $mutable): self
     {
         $this->elements['mutable_content'] = $mutable;
 
@@ -202,11 +202,11 @@ class FCMPayload
     /**
      * Mark the notification priority.
      *
-     * @param FCMPriority $priority Notification priority value.
+     * @param FCMPriority::* $priority Notification priority value.
      *
      * @return FCMPayload Self Reference
      */
-    public function set_priority($priority)
+    public function set_priority(string $priority): self
     {
         $priority       = strtolower($priority);
         $priority_class = new ReflectionClass('\Lunr\Vortex\FCM\FCMPriority');
@@ -226,7 +226,7 @@ class FCMPayload
      *
      * @return FCMPayload Self Reference
      */
-    public function set_options($key, $value)
+    public function set_options(string $key, string $value): self
     {
         $this->elements['fcm_options'][$key] = $value;
 
diff --git a/src/Lunr/Vortex/FCM/FCMPriority.php b/src/Lunr/Vortex/FCM/FCMPriority.php
index d4d724507574102597c8d2519399720d913fc3d0..5e2414388d12824dc5ace1e3f166d684ffd19b85 100644
--- a/src/Lunr/Vortex/FCM/FCMPriority.php
+++ b/src/Lunr/Vortex/FCM/FCMPriority.php
@@ -21,13 +21,13 @@ class FCMPriority
      * Deliver notification immediately.
      * @var string
      */
-    const HIGH = 'high';
+    public const HIGH = 'high';
 
     /**
      * Deliver notification with normal priority.
      * @var string
      */
-    const NORMAL = 'normal';
+    public const NORMAL = 'normal';
 
 }
 
diff --git a/src/Lunr/Vortex/FCM/FCMResponse.php b/src/Lunr/Vortex/FCM/FCMResponse.php
index 23d1ec9925396ddda2243f3b7eb7564dd67c4cba..7c51cd4210a35439fe527878cd3bd0d6661417d5 100644
--- a/src/Lunr/Vortex/FCM/FCMResponse.php
+++ b/src/Lunr/Vortex/FCM/FCMResponse.php
@@ -24,7 +24,7 @@ class FCMResponse implements PushNotificationResponseInterface
      * The statuses per endpoint.
      * @var array<string, PushNotificationStatus::*>
      */
-    protected $statuses;
+    protected array $statuses;
 
     /**
      * Constructor.
@@ -50,7 +50,7 @@ class FCMResponse implements PushNotificationResponseInterface
      *
      * @return void
      */
-    public function add_batch_response($batch_response, $endpoints)
+    public function add_batch_response(FCMBatchResponse $batch_response, array $endpoints): void
     {
         foreach ($endpoints as $endpoint)
         {
@@ -65,7 +65,7 @@ class FCMResponse implements PushNotificationResponseInterface
      *
      * @return PushNotificationStatus::* Delivery status for the endpoint
      */
-    public function get_status($endpoint)
+    public function get_status(string $endpoint): int
     {
         return isset($this->statuses[$endpoint]) ? $this->statuses[$endpoint] : PushNotificationStatus::UNKNOWN;
     }
diff --git a/src/Lunr/Vortex/FCM/Tests/FCMDispatcherBaseTest.php b/src/Lunr/Vortex/FCM/Tests/FCMDispatcherBaseTest.php
index c2dd4435ac10eba8a3a5ff39cfb3b95ea1531c8d..48cd868a37d80e87c4989e52575564c65a10b276 100644
--- a/src/Lunr/Vortex/FCM/Tests/FCMDispatcherBaseTest.php
+++ b/src/Lunr/Vortex/FCM/Tests/FCMDispatcherBaseTest.php
@@ -75,12 +75,8 @@ class FCMDispatcherBaseTest extends FCMDispatcherTest
      */
     public function testGetBatchResponseReturnsFCMBatchResponseObject(): void
     {
-        $this->http->expects($this->atLeast(1))
-                   ->method('__get')
-                   ->willReturnMap([['status_code', 500]]);
-
         $method = $this->get_accessible_reflection_method('get_batch_response');
-        $result = $method->invokeArgs($this->class, [ $this->http, $this->logger, [ 'endpoint' ], '{}' ]);
+        $result = $method->invokeArgs($this->class, [ $this->response, $this->logger, [ 'endpoint' ], '{}' ]);
 
         $this->assertInstanceOf('Lunr\Vortex\FCM\FCMBatchResponse', $result);
     }
diff --git a/src/Lunr/Vortex/FCM/Tests/FCMDispatcherTest.php b/src/Lunr/Vortex/FCM/Tests/FCMDispatcherTest.php
index 3b774120daeb6ee06737b1a404e8e783c52170ea..32a3ee76a3592cb45af580db928c3ff8c057f0a1 100644
--- a/src/Lunr/Vortex/FCM/Tests/FCMDispatcherTest.php
+++ b/src/Lunr/Vortex/FCM/Tests/FCMDispatcherTest.php
@@ -13,6 +13,7 @@ namespace Lunr\Vortex\FCM\Tests;
 
 use Lunr\Vortex\FCM\FCMDispatcher;
 use Lunr\Halo\LunrBaseTest;
+use Lunr\Vortex\FCM\FCMPayload;
 use ReflectionClass;
 
 /**
@@ -29,6 +30,12 @@ abstract class FCMDispatcherTest extends LunrBaseTest
      */
     protected $http;
 
+    /**
+     * Mock instance of the Requests_Response class.
+     * @var \Requests_Response
+     */
+    protected $response;
+
     /**
      * Mock instance of a Logger class.
      * @var \Psr\Log\LoggerInterface
@@ -46,10 +53,10 @@ abstract class FCMDispatcherTest extends LunrBaseTest
      */
     public function setUp(): void
     {
-        $this->http   = $this->getMockBuilder('Requests_Session')->getMock();
-        $this->logger = $this->getMockBuilder('Psr\Log\LoggerInterface')->getMock();
-
-        $this->payload = $this->getMockBuilder('Lunr\Vortex\FCM\FCMPayload')
+        $this->http     = $this->getMockBuilder('Requests_Session')->getMock();
+        $this->response = $this->getMockBuilder('Requests_Response')->getMock();
+        $this->logger   = $this->getMockBuilder('Psr\Log\LoggerInterface')->getMock();
+        $this->payload  = $this->getMockBuilder('Lunr\Vortex\FCM\FCMPayload')
                               ->disableOriginalConstructor()
                               ->getMock();
 
diff --git a/src/Lunr/Vortex/FCM/Tests/FCMPayloadSetTest.php b/src/Lunr/Vortex/FCM/Tests/FCMPayloadSetTest.php
index 2b636843867d76c7270cf24fcd707c5907638db4..59bd29801e1aed8e7673eaef3bb54040387710b2 100644
--- a/src/Lunr/Vortex/FCM/Tests/FCMPayloadSetTest.php
+++ b/src/Lunr/Vortex/FCM/Tests/FCMPayloadSetTest.php
@@ -66,7 +66,7 @@ class FCMPayloadSetTest extends FCMPayloadTest
      */
     public function testSetTimeToLiveReturnsSelfReference(): void
     {
-        $this->assertSame($this->class, $this->class->set_time_to_live('time_to_live'));
+        $this->assertSame($this->class, $this->class->set_time_to_live(15));
     }
 
     /**
@@ -91,7 +91,7 @@ class FCMPayloadSetTest extends FCMPayloadTest
      */
     public function testSetNotificationReturnsSelfReference(): void
     {
-        $this->assertSame($this->class, $this->class->set_notification('data'));
+        $this->assertSame($this->class, $this->class->set_notification([]));
     }
 
     /**
@@ -181,7 +181,7 @@ class FCMPayloadSetTest extends FCMPayloadTest
      */
     public function testSetDataReturnsSelfReference(): void
     {
-        $this->assertSame($this->class, $this->class->set_data('data'));
+        $this->assertSame($this->class, $this->class->set_data([]));
     }
 
     /**
diff --git a/src/Lunr/Vortex/JPush/JPushBatchResponse.php b/src/Lunr/Vortex/JPush/JPushBatchResponse.php
index e0297cd7507b3475cbad8331691d959958191a84..aa2947ff1ef03c0b9787c6e67e42d4938272a9d8 100644
--- a/src/Lunr/Vortex/JPush/JPushBatchResponse.php
+++ b/src/Lunr/Vortex/JPush/JPushBatchResponse.php
@@ -12,6 +12,7 @@
 namespace Lunr\Vortex\JPush;
 
 use Lunr\Vortex\PushNotificationStatus;
+use Psr\Log\LoggerInterface;
 use Requests_Exception;
 
 /**
@@ -24,43 +25,43 @@ class JPushBatchResponse
      * JPush Report API URL.
      * @var string
      */
-    const JPUSH_REPORT_URL = 'https://report.jpush.cn/v3/status/message';
+    private const JPUSH_REPORT_URL = 'https://report.jpush.cn/v3/status/message';
 
     /**
      * Shared instance of a Logger class.
      * @var \Psr\Log\LoggerInterface
      */
-    private $logger;
+    private LoggerInterface $logger;
 
     /**
      * Shared instance of the Requests_Session class.
      * @var \Requests_Session
      */
-    protected $http;
+    protected \Requests_Session $http;
 
     /**
      * The statuses per endpoint.
      * @var array
      */
-    private $statuses;
+    private array $statuses;
 
     /**
      * Raw payload that was sent to JPush.
      * @var array
      */
-    protected $payload;
+    protected array $payload;
 
     /**
      * Message ID.
      * @var integer
      */
-    protected $message_id;
+    protected int $message_id;
 
     /**
      * Notification endpoints.
      * @var array
      */
-    protected $endpoints;
+    protected array $endpoints;
 
     /**
      * Constructor.
@@ -71,7 +72,7 @@ class JPushBatchResponse
      * @param array                    $endpoints The endpoints the message was sent to (in the same order as sent).
      * @param array                    $payload   Raw payload that was sent to JPush.
      */
-    public function __construct($http, $logger, $response, $endpoints, $payload)
+    public function __construct(\Requests_Session $http, LoggerInterface $logger, \Requests_Response $response, array $endpoints, array $payload)
     {
         $this->statuses  = [];
         $this->http      = $http;
@@ -114,7 +115,7 @@ class JPushBatchResponse
      *
      * @return void
      */
-    private function set_statuses()
+    private function set_statuses(): void
     {
 
         $payload = [
@@ -153,7 +154,7 @@ class JPushBatchResponse
      *
      * @return PushNotificationStatus::* Delivery status for the endpoint
      */
-    public function get_status($endpoint)
+    public function get_status(string $endpoint): int
     {
         if ($this->statuses === [])
         {
@@ -173,7 +174,7 @@ class JPushBatchResponse
      *
      * @return void
      */
-    private function report_error(&$endpoints, $response)
+    private function report_error(array &$endpoints, \Requests_Response $response): void
     {
         $upstream_msg = NULL;
         if (!empty($response->body))
@@ -227,7 +228,7 @@ class JPushBatchResponse
      *
      * @return void
      */
-    private function report_endpoint_error($endpoint, $error_code)
+    private function report_endpoint_error(string $endpoint, string $error_code): void
     {
         switch ($error_code)
         {
diff --git a/src/Lunr/Vortex/JPush/JPushDispatcher.php b/src/Lunr/Vortex/JPush/JPushDispatcher.php
index 3790c2a83112e0ac5327195851ac260375644f69..3d689ec7de3be857a30ce71488504dd667535d41 100644
--- a/src/Lunr/Vortex/JPush/JPushDispatcher.php
+++ b/src/Lunr/Vortex/JPush/JPushDispatcher.php
@@ -12,6 +12,8 @@
 namespace Lunr\Vortex\JPush;
 
 use Lunr\Vortex\PushNotificationMultiDispatcherInterface;
+use Lunr\Vortex\PushNotificationResponseInterface;
+use Psr\Log\LoggerInterface;
 use Requests_Exception;
 use Requests_Response;
 
@@ -25,37 +27,37 @@ class JPushDispatcher implements PushNotificationMultiDispatcherInterface
      * Maximum number of endpoints allowed in one push.
      * @var integer
      */
-    const BATCH_SIZE = 1000;
+    private const BATCH_SIZE = 1000;
 
     /**
      * Url to send the JPush push notification to.
      * @var string
      */
-    const JPUSH_SEND_URL = 'https://api.jpush.cn/v3/push';
+    private const JPUSH_SEND_URL = 'https://api.jpush.cn/v3/push';
 
     /**
      * Service name.
      * @var string
      */
-    const SERVICE_NAME = 'JPush';
+    private const SERVICE_NAME = 'JPush';
 
     /**
      * Push Notification authentication token.
      * @var string|null
      */
-    protected $auth_token;
+    protected ?string $auth_token;
 
     /**
      * Shared instance of the Requests_Session class.
      * @var \Requests_Session
      */
-    protected $http;
+    protected \Requests_Session $http;
 
     /**
      * Shared instance of a Logger class.
      * @var \Psr\Log\LoggerInterface
      */
-    protected $logger;
+    protected LoggerInterface $logger;
 
     /**
      * Constructor.
@@ -63,7 +65,7 @@ class JPushDispatcher implements PushNotificationMultiDispatcherInterface
      * @param \Requests_Session        $http   Shared instance of the Requests_Session class.
      * @param \Psr\Log\LoggerInterface $logger Shared instance of a Logger.
      */
-    public function __construct($http, $logger)
+    public function __construct(\Requests_Session $http, LoggerInterface $logger)
     {
         $this->http       = $http;
         $this->logger     = $logger;
@@ -90,7 +92,7 @@ class JPushDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return JPushResponse
      */
-    public function get_response()
+    public function get_response(): JPushResponse
     {
         return new JPushResponse();
     }
@@ -104,7 +106,7 @@ class JPushDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return JPushBatchResponse
      */
-    public function get_batch_response($http_response, $endpoints, $payload)
+    public function get_batch_response(Requests_Response $http_response, array $endpoints, array $payload): JPushBatchResponse
     {
         return new JPushBatchResponse($this->http, $this->logger, $http_response, $endpoints, $payload);
     }
@@ -115,9 +117,9 @@ class JPushDispatcher implements PushNotificationMultiDispatcherInterface
      * @param JPushPayload $payload   Payload object
      * @param string[]     $endpoints Endpoints to send to in this batch
      *
-     * @return JPushResponse Response object
+     * @return PushNotificationResponseInterface&JPushResponse Response object
      */
-    public function push($payload, &$endpoints)
+    public function push(object $payload, array &$endpoints): PushNotificationResponseInterface
     {
         $response = $this->get_response();
 
@@ -143,7 +145,7 @@ class JPushDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return JPushBatchResponse Response object
      */
-    protected function push_batch($payload, &$endpoints)
+    protected function push_batch(JPushPayload $payload, array &$endpoints): JPushBatchResponse
     {
 
         $tmp_payload = $payload->get_payload();
@@ -177,7 +179,7 @@ class JPushDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return JPushDispatcher Self reference
      */
-    public function set_auth_token($auth_token)
+    public function set_auth_token(string $auth_token): self
     {
         $this->auth_token = $auth_token;
 
@@ -194,7 +196,7 @@ class JPushDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return \Requests_Response New instance of a Requests_Response object.
      */
-    protected function get_new_response_object_for_failed_request()
+    protected function get_new_response_object_for_failed_request(): Requests_Response
     {
         $http_response = new Requests_Response();
 
diff --git a/src/Lunr/Vortex/JPush/JPushMessagePayload.php b/src/Lunr/Vortex/JPush/JPushMessagePayload.php
index 51ff722a3daf7128696b3974f057598478258150..6c42745f9e8ccf59b72b982dd20518bcc7e783b1 100644
--- a/src/Lunr/Vortex/JPush/JPushMessagePayload.php
+++ b/src/Lunr/Vortex/JPush/JPushMessagePayload.php
@@ -38,7 +38,7 @@ class JPushMessagePayload extends JPushPayload
      *
      * @return array JPushPayload
      */
-    public function get_payload()
+    public function get_payload(): array
     {
         $elements = $this->elements;
 
diff --git a/src/Lunr/Vortex/JPush/JPushNotificationPayload.php b/src/Lunr/Vortex/JPush/JPushNotificationPayload.php
index 0bd14cc9953e3ca58dbc6708f0fe6b3019934b5d..21009b996b8d2777a949a9dd40dd7117a345093d 100644
--- a/src/Lunr/Vortex/JPush/JPushNotificationPayload.php
+++ b/src/Lunr/Vortex/JPush/JPushNotificationPayload.php
@@ -42,7 +42,7 @@ class JPushNotificationPayload extends JPushPayload
      *
      * @return array JPushPayload
      */
-    public function get_payload()
+    public function get_payload(): array
     {
         $elements = $this->elements;
 
@@ -56,9 +56,9 @@ class JPushNotificationPayload extends JPushPayload
      *
      * @param string $sound The notification sound
      *
-     * @return JPushPayload Self Reference
+     * @return JPushNotificationPayload Self Reference
      */
-    public function set_sound($sound)
+    public function set_sound(string $sound): self
     {
         return $this->set_notification_data('sound', $sound);
     }
@@ -68,9 +68,9 @@ class JPushNotificationPayload extends JPushPayload
      *
      * @param boolean $val Value for the "content_available" field.
      *
-     * @return JPushPayload Self Reference
+     * @return JPushNotificationPayload Self Reference
      */
-    public function set_content_available($val)
+    public function set_content_available(bool $val): self
     {
         return $this->set_notification_data('content-available', $val, ['ios']);
     }
@@ -80,9 +80,9 @@ class JPushNotificationPayload extends JPushPayload
      *
      * @param boolean $mutable Notification mutable_content value.
      *
-     * @return JPushPayload Self Reference
+     * @return JPushNotificationPayload Self Reference
      */
-    public function set_mutable_content($mutable)
+    public function set_mutable_content(bool $mutable): self
     {
         return $this->set_notification_data('mutable-content', $mutable, ['ios']);
     }
@@ -90,11 +90,11 @@ class JPushNotificationPayload extends JPushPayload
     /**
      * Mark the notification priority.
      *
-     * @param JPushPriority $priority Notification priority value.
+     * @param JPushPriority::* $priority Notification priority value.
      *
-     * @return JPushPayload Self Reference
+     * @return JPushNotificationPayload Self Reference
      */
-    public function set_priority($priority)
+    public function set_priority(int $priority): self
     {
         $priority_class = new ReflectionClass('\Lunr\Vortex\JPush\JPushPriority');
         $priorities     = array_values($priority_class->getConstants());
diff --git a/src/Lunr/Vortex/JPush/JPushPayload.php b/src/Lunr/Vortex/JPush/JPushPayload.php
index 08a2b46c8cbe0bc933639cfb4e2fe75e812b10f6..622ae6191980a3505eb9a4e12339bdaade11e88c 100644
--- a/src/Lunr/Vortex/JPush/JPushPayload.php
+++ b/src/Lunr/Vortex/JPush/JPushPayload.php
@@ -21,13 +21,13 @@ abstract class JPushPayload
      * Array of Push Notification elements.
      * @var array
      */
-    protected $elements;
+    protected array $elements;
 
     /**
      * Supported push platforms
      * @var array
      */
-    const PLATFORMS = ['ios', 'android'];
+    private const PLATFORMS = ['ios', 'android'];
 
     /**
      * Constructor.
@@ -55,7 +55,7 @@ abstract class JPushPayload
      *
      * @return array JPushPayload
      */
-    public abstract function get_payload();
+    public abstract function get_payload(): array;
 
     /**
      * Sets the notification identifier.
@@ -64,7 +64,7 @@ abstract class JPushPayload
      *
      * @return JPushPayload Self Reference
      */
-    public function set_notification_identifier($identifier)
+    public function set_notification_identifier(string $identifier): self
     {
         $this->elements['cid'] = $identifier;
 
@@ -78,7 +78,7 @@ abstract class JPushPayload
      *
      * @return JPushPayload Self Reference
      */
-    public function set_body($message)
+    public function set_body(string $message): self
     {
         return $this->set_message_data('msg_content', $message)
                     ->set_notification_data('alert', $message);
@@ -91,7 +91,7 @@ abstract class JPushPayload
      *
      * @return JPushPayload Self Reference
      */
-    public function set_title($message)
+    public function set_title(string $message): self
     {
         return $this->set_message_data('title', $message)
                     ->set_notification_data('title', $message, ['android']);
@@ -106,7 +106,7 @@ abstract class JPushPayload
      *
      * @return JPushPayload Self Reference
      */
-    public function set_data($data)
+    public function set_data(array $data): self
     {
         return $this->set_message_data('extras', $data)
                     ->set_notification_data('extras', $data);
@@ -119,7 +119,7 @@ abstract class JPushPayload
      *
      * @return JPushPayload Self Reference
      */
-    public function set_category($category)
+    public function set_category(string $category): self
     {
         return $this->set_message_data('content_type', $category)
                     ->set_notification_data('category', $category);
@@ -135,7 +135,7 @@ abstract class JPushPayload
      *
      * @return JPushPayload Self Reference
      */
-    public function set_time_to_live($ttl)
+    public function set_time_to_live(int $ttl): self
     {
         $this->set_options('time_to_live', $ttl);
 
@@ -152,7 +152,7 @@ abstract class JPushPayload
      *
      * @return JPushPayload Self Reference
      */
-    public function set_collapse_key($key)
+    public function set_collapse_key(string $key): self
     {
         $this->set_options('apns_collapse_id', $key);
 
@@ -167,7 +167,7 @@ abstract class JPushPayload
      *
      * @return JPushPayload Self Reference
      */
-    public function set_options($key, $value)
+    public function set_options(string $key, string $value): self
     {
         if (!isset($this->elements['options']))
         {
@@ -188,7 +188,7 @@ abstract class JPushPayload
      *
      * @return JPushPayload Self Reference
      */
-    protected function set_notification_data($key, $value, $platforms = self::PLATFORMS)
+    protected function set_notification_data(string $key, $value, array $platforms = self::PLATFORMS): self
     {
         foreach ($platforms as $platform)
         {
@@ -206,7 +206,7 @@ abstract class JPushPayload
      *
      * @return JPushPayload Self Reference
      */
-    protected function set_message_data($key, $value)
+    protected function set_message_data(string $key, $value): self
     {
         $this->elements['message'][$key] = $value;
 
diff --git a/src/Lunr/Vortex/JPush/JPushPriority.php b/src/Lunr/Vortex/JPush/JPushPriority.php
index 06200552482706e683758ec7666c86d4b41de403..b6d83c130e2d712c2c5a6fa66487a00b7d76fa7a 100644
--- a/src/Lunr/Vortex/JPush/JPushPriority.php
+++ b/src/Lunr/Vortex/JPush/JPushPriority.php
@@ -19,33 +19,33 @@ class JPushPriority
 
     /**
      * Deliver notification immediately.
-     * @var string
+     * @var int
      */
-    const HIGH = 2;
+    public const HIGH = 2;
 
     /**
      * Deliver notification with medium priority.
-     * @var string
+     * @var int
      */
-    const MEDIUM = 1;
+    public const MEDIUM = 1;
 
     /**
      * Deliver notification with normal priority.
-     * @var string
+     * @var int
      */
-    const NORMAL = 0;
+    public const NORMAL = 0;
 
     /**
      * Deliver notification with low priority.
-     * @var string
+     * @var int
      */
-    const LOW = -1;
+    public const LOW = -1;
 
     /**
      * Deliver notification with no priority.
-     * @var string
+     * @var int
      */
-    const NONE = -2;
+    public const NONE = -2;
 
 }
 
